package com.gic.enterprise.dao.mapper;

import com.gic.enterprise.dto.union.UnionEnterpriseAuthListDTO;
import com.gic.enterprise.entity.TabSysUnionEnterpriseAuth;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 联合商户
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/2/3 7:56 PM 
 */
public interface TabSysUnionEnterpriseAuthMapper {

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabSysUnionEnterpriseAuth record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabSysUnionEnterpriseAuth record);

    /**
     * 根据主键查询
     *
     * @param unionEnterpriseAuthId 主键
     * @return 实体对象
     */
    TabSysUnionEnterpriseAuth selectByPrimaryKey(Integer unionEnterpriseAuthId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabSysUnionEnterpriseAuth record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabSysUnionEnterpriseAuth record);

    /**
     * 查询未解除联合的商户数据
     * @param ownEnterpriseId
     * @param unionEnterpriseId
     * @return
     */
    TabSysUnionEnterpriseAuth getUnionEnterprise(@Param("ownEnterpriseId") Integer ownEnterpriseId,
                                                 @Param("unionEnterpriseId") Integer unionEnterpriseId);

    /**
     * 联合商户列表接口
     * @param ownEnterpriseId
     * @param unionEnterpriseIdList
     * @param authStatus
     * @return
     */
    List<UnionEnterpriseAuthListDTO> listUnionEnterpriseAuth(@Param("ownEnterpriseId") Integer ownEnterpriseId,
                                                             @Param("list") List<Integer> unionEnterpriseIdList,
                                                             @Param("authStatus") Integer authStatus);
}