package com.gic.enterprise.service.impl;

import com.gic.enterprise.constant.union.UnionEnterpriseAuthDetailStatusEnum;
import com.gic.enterprise.constant.union.UnionEnterpriseAuthResTypeEnum;
import com.gic.enterprise.dao.mapper.TabSysUnionEnterpriseAuthResDetailMapper;
import com.gic.enterprise.entity.TabSysUnionEnterpriseAuthResDetail;
import com.gic.enterprise.service.UnionEnterpriseAuthResDetailService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.validation.constraints.NotNull;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Optional;

@Service("unionEnterpriseAuthResDetailService")
public class UnionEnterpriseAuthResDetailServiceImpl implements UnionEnterpriseAuthResDetailService{
    @Autowired
    private TabSysUnionEnterpriseAuthResDetailMapper tabSysUnionEnterpriseAuthResDetailMapper;

    @Override
    public List<TabSysUnionEnterpriseAuthResDetail> listUnionEnterpriseAuthResDetail(Integer unionEnterpriseAuthId, Integer authStatus) {
        return Optional.ofNullable(tabSysUnionEnterpriseAuthResDetailMapper
                .listUnionEnterpriseAuthResDetail(unionEnterpriseAuthId, authStatus))
                .orElse(Collections.emptyList());
    }

    @Override
    public TabSysUnionEnterpriseAuthResDetail getUnionEnterpriseAuthResDetail(@NotNull Integer unionEnterpriseAuthId, @NotNull Integer resourceType) {
        List<TabSysUnionEnterpriseAuthResDetail> list = listUnionEnterpriseAuthResDetail(unionEnterpriseAuthId, null);
        if (CollectionUtils.isNotEmpty(list)) {
            for (TabSysUnionEnterpriseAuthResDetail obj : list) {
                if (obj.getResourceType().equals(resourceType)) {
                    return obj;
                }
            }
        }
        return null;
    }

    @Override
    public void initUnionEnterpriseAuthResDetail(@NotNull Integer unionEnterpriseAuthId) {
        if (CollectionUtils.isNotEmpty(listUnionEnterpriseAuthResDetail(unionEnterpriseAuthId, null))) {
            return;
        }
        Date now = new Date();
        //因为资源种类不多，循环单条创建
        for (UnionEnterpriseAuthResTypeEnum typeEnum : UnionEnterpriseAuthResTypeEnum.values()) {
            TabSysUnionEnterpriseAuthResDetail record = new TabSysUnionEnterpriseAuthResDetail();
            record.setUpdateTime(now)
                    .setCreateTime(now)
                    .setDeleteFlag(0)
                    .setUnionEnterpriseAuthId(unionEnterpriseAuthId)
                    .setResourceType(typeEnum.getCode())
                    .setAuthStatus(UnionEnterpriseAuthDetailStatusEnum.NO_AUTH.getCode());
            tabSysUnionEnterpriseAuthResDetailMapper.insertSelective(record);
        }
    }

    @Override
    public List<TabSysUnionEnterpriseAuthResDetail> listByUnionEnterpriseAuthIdList(List<Integer> unionEnterpriseAuthIdList) {
        return tabSysUnionEnterpriseAuthResDetailMapper.listByUnionEnterpriseAuthIdList(unionEnterpriseAuthIdList);
    }
}
