package com.gic.enterprise.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.constant.union.UnionEnterpriseAuthStatusEnum;
import com.gic.enterprise.dao.mapper.TabSysUnionEnterpriseAuthMapper;
import com.gic.enterprise.dto.union.UnionEnterpriseAuthDTO;
import com.gic.enterprise.dto.union.UnionEnterpriseAuthListDTO;
import com.gic.enterprise.entity.TabSysUnionEnterpriseAuth;
import com.gic.enterprise.service.UnionEnterpriseAuthService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * 联合商户
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/2/3 1:57 PM 
 */
@Service("unionEnterpriseAuthService")
public class UnionEnterpriseAuthServiceImpl implements UnionEnterpriseAuthService{
    @Autowired
    private TabSysUnionEnterpriseAuthMapper tabSysUnionEnterpriseAuthMapper;

    @Override
    public int saveUnionEnterprise(Integer ownEnterpriseId, Integer unionEnterpriseId) {
        TabSysUnionEnterpriseAuth record = new TabSysUnionEnterpriseAuth();
        Date now = new Date();
        record.setCreateTime(now)
                .setUpdateTime(now)
                .setDeleteFlag(0)
                .setOwnEnterpriseId(ownEnterpriseId)
                .setUnionEnterpriseId(unionEnterpriseId)
                .setStatusFlag(UnionEnterpriseAuthStatusEnum.NORMAL.getCode());
        return tabSysUnionEnterpriseAuthMapper.insertSelective(record);
    }

    @Override
    public TabSysUnionEnterpriseAuth getUnionEnterprise(Integer ownEnterpriseId, Integer unionEnterpriseId) {
        return tabSysUnionEnterpriseAuthMapper.getUnionEnterprise(ownEnterpriseId, unionEnterpriseId);
    }

    @Override
    public int update(UnionEnterpriseAuthDTO dto) {
        TabSysUnionEnterpriseAuth record = EntityUtil.changeEntityNew(TabSysUnionEnterpriseAuth.class, dto);
        record.setUpdateTime(new Date());
        return tabSysUnionEnterpriseAuthMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public List<UnionEnterpriseAuthListDTO> listUnionEnterpriseAuth(Integer ownEnterpriseId, List<Integer> unionEnterpriseIdList, Integer authStatus) {
        return tabSysUnionEnterpriseAuthMapper.listUnionEnterpriseAuth(ownEnterpriseId, unionEnterpriseIdList, authStatus);
    }
}
